Part Feature

From FreeCAD Documentation
Revision as of 19:36, 6 October 2019 by FuzzyBot (talk | contribs) (Updating to match new version of source page)

Introduction

A Part Feature object, or formally a Part::Feature, is a simple element with a topological Shape associated that can be displayed in the 3D view.

The Part::Feature is defined in the Part Workbench but can be used as the base class for scripted objects in all workbenches that produce 2D and 3D geometrical shapes.

A Part::Feature has simple properties like a placement, and colors to define the appearance of its vertices, edges, and faces. Workbenches can add more properties to this basic element to produce an object with complex behavior.

Properties

See Property for all property types that scripted objects can have.

These are the properties available in the property editor.

Data

Base

  • DataPlacement: the position of the object in the 3D view. The placement is defined by a Base point (vector), and a Rotation (axis and angle).
    • DataAngle: the angle of rotation around the DataAxis.
    • DataAxis: the unit vector that defines the axis of rotation for the placement. Each value is between 0 and 1. If any value is above 1, the vector is normalized so that the magnitude of the vector is 1.
    • DataPosition: the 3D coordinates of the base point of the placement.
  • DataLabel: the user editable description of this object.

View

Base

  • ViewAngular Deflection: it is a companion to ViewDeviation. It is another way to specify how finely to generate the mesh for rendering on screen or when exporting. The default value is 28.5 degrees, or 0.5 radians. The smaller the value the smoother the appearance will be in the 3D view, and the finer the mesh that will be exported.
  • ViewBounding Box: if it is true, the object will show the bounding box in the 3D view.
  • ViewDeviation: it is a companion to ViewAngular Deflection. It is another way to specify how finely to generate the mesh for rendering on screen or when exporting. The default value is 0.5. The smaller the value the smoother the appearance will be in the 3D view, and the finer the mesh that will be exported.
  • ViewDisplay Mode: Flat Lines (regular visualization), Shaded (soft edges), Wireframe (no faces), Points (only vertices).
  • ViewDraw Style: Solid, Dashed, Dotted, Dashdot; defines the style of the edges in the 3D view.
  • ViewLighting: Two side, One side; the illumination comes from two sides or one side in the 3D view.
  • ViewLine Color: a tuple of three values (r,g,b) to define the color of the edges in the 3D view.
  • ViewLine Width: a float that determines the width in pixels of the edges in the 3D view.
  • ViewOn Top When Selected: Disabled, Enabled, Object, Element.
  • ViewPoint Color: a tuple of three values (r,g,b) to define the color of the vertices in the 3D view.
  • ViewPoint Size: a float that determines the size in pixels of the vertices in the 3D view.
  • ViewSelectable: if it is true, the object can be picked with the pointer in the 3D view. Otherwise, the object cannot be selected until this option is set to true.
  • ViewSelection Style: Shape, BoundBox.
  • ViewShape Color: a tuple of three values (r,g,b) to define the color of the faces in the 3D view.
  • ViewShow In Tree: if it is true, the object appears in the tree view. Otherwise, it is set as invisible.
  • ViewTransparency: a float from 0 to 100 that determines the level of transparency of the faces in the 3D view. A value of 100 indicates completely invisible faces; the faces are invisible but they can still be picked as long as ViewSelectable is true.
  • ViewVisibility: if it is true, the object appears in the 3D view; otherwise it is not present.

Scripting

See also: FreeCAD Scripting Basics, and scripted objects.

A Part Feature is created with the addObject() method of the document.

obj = App.ActiveDocument.addObject("Part::Feature", "Name")
obj.Label = "Custom label"
  • The first argument indicates the type of object, in this case, "Part::Feature".
  • The second argument is a string that defines the Name attribute. If it is not provided, it defaults to "Part__Feature".
    • The Name is fixed at creation time; it cannot be modified afterwards.
    • The Name can only include simple alphanumeric characters, and the underscore, [_0-9a-zA-Z]. If other symbols are given, these will be converted to underscores; for example, "A+B:C*" is converted to "A_B_C_".
    • The Name must be unique in the entire document. If more objects with the same name are created, a sequential number will be appended to distinguish them, for example, "Name001", "Name002", etc.
  • If desired, the Label attribute can be changed to a more meaningful text.
    • By default, the Label is equal to the Name.
    • Unlike the Name, the Label can accept any UTF8 string, including accents and spaces. Since the tree view displays the Label, it is a good practice to change the Label to a more descriptive string.
    • By default the Label must be unique. This behavior can be changed in the preferences editor, Edit → Preferences → General → Document → Allow duplicate object labels in one document.